
include
	
Checkers:
.init
	STZ !brightness
	STZ !tilemaptimer

	REP #$20

	STZ !BG2xpos
	LDA #$000F
	STA !BG2ypos

	LDA #$0043
	STA !BG3ypos

	LDA #$0704	;current and max positions
	STA !cursorXpos
	STA !cursorYpos

	LDA #.cursorYposTable
	STA !cursorpostable
	LDA #.cursorYposTable+8
	STA !cursorpostable+2

	LDA #.cursorXposTable
	STA !cursorpostable+4
	LDA #.cursorXposTable+8
	STA !cursorpostable+6

	SEP #$20

	LDA #%00001000
	STA !cursorpalette1
	LDA #%00001110
	STA !cursorpalette2

	JSR .prepareCheckers

	LDA #$80
	STA !currentselection

	LDA #$0B*4
	STA !capturedidx1
	LDA #$17*4
	STA !capturedidx2

	LDA !turnorder
	CMP #$04
	BCC +
	JSR GetRand
	AND #$02
+	STA !currentplayer

	JSR SquareCursorInit

	INC !gamemode
	STZ !substate
	RTS

.main
	LDX #$02
-	LDA !controller1holdbyetUDLR,x
	BIT #$10
	BEQ +
	LDA !backtimer1,x
	INC
	STA !backtimer1,x
	CMP #$3C
	BNE ++
	INC !fadeinout
	STZ !substate
	RTS

+	STZ !backtimer1,x
++	DEX #2
	BPL -
	
	LDA !substate
	ASL
	TAX
	JMP (.MainPointers,x)

.MainPointers
dw FadeMain, .tilemapDrawMain, .mainMain, .moveChecker, EndMain

.tilemapDrawMain
	LDA !tilemaptimer
	CMP #$1F
	BEQ +
	INC !tilemaptimer
	RTS

+	JSR .legalMoves
	INC !substate
	RTS

.mainMain
	JSR CursorUpdate

	LDX !currentplayer
	BIT !controller1pressbyetUDLR,x
	BMI ++++

	LDA #$01
	TRB !chaincapture
	BNE ++

	BIT !controller1pressaxlr0000,x
	BPL +

	;A button to comfirm selection
++	LDA !cursorYpos
	ASL #3
	ADC !cursorXpos
	TAX

	BIT !currentselection
	BPL +++

	LDA !playfield,x
	BEQ +

	AND #%10000000
	ORA !currentplayer
	BEQ ++
	CMP #%10000010
	BNE +

	;P1 selecting red or P2 selecting white
++	STX !currentselection
	LDA !playfield,x
	AND #%00011111
	ASL #2
	TAX

	LDA !OAM+$12,x
	ORA #$20
	STA !OAM+$12,x

+	RTS

	;B button to cancel selection
++++
	LDA !currentselection
	BMI +

-	AND #%00000111
	STA !cursorXpos
	TAY

	LDA !currentselection
	TAX

	AND #%00111000
	PHA
	LSR #3
	STA !cursorYpos

	LDA !playfield,x
	AND #%00011111
	ASL #2
	TAX

	TYA
	ASL #4
	ADC #$40
	STA !OAM+$10,x

	PLA
	ASL
	ADC #$30
	STA !OAM+$11,x

	LDA !OAM+$12,x
	AND #$DF
	STA !OAM+$12,x

;	LDA !OAM+$13,x
;	AND #%11101111
;	STA !OAM+$13,x

	LDA #$80
	STA !currentselection

+	RTS

	;a checker is currently selected, A button pressed
+++	CMP !currentselection
	BEQ -

	;check if move is legal
	STA $01
	SEC
	SBC !currentselection
	STA $00	;new - old

	LDX !currentselection
	LDA !playfield+$40,x
	
	LDX #$07
-	LSR
	BCC +
	LDY .movesOffsets,x
	CPY $00
	BEQ ++

+	DEX
	BPL -
	RTS

++	STX !movetype	;odd = capture
	TXA
	LSR
	BCC +

	DEX
	LDA .movesOffsets,x
	CLC
	ADC !currentselection	;get the position of the captured piece
	TAX
	LDA !playfield,x
	STA !captureposition
	STZ !playfield,x

+	LDX !currentselection
	LDA !playfield,x
	STZ !playfield,x

;	LDX !cursorYpos	;
;	BEQ +			;
;	CPX #$07		;if on first or last row
;	BNE ++			;

;+	ORA #%01000000	;promote
++	LDX $01
	STA !playfield,x

	JSR SquareCursorClear

	INC !substate
-	RTS

;↖⇖↗⇗↙⇙↘⇘
.movesOffsets
db -$09, -$12, -$07, -$0E, $07, $0E, $09, $12

.columnsCheck
db $06
.rowOffsetsNeutral
db !playfield+$10, $07, !playfield+$08
.rowOffsetsTopRight
db !playfield+$10-$07, !playfield+$10-$0E
db !playfield+$08-$07, !playfield+$08-$0E
.rowOffsetsTopLeft
db !playfield+$10-$09, !playfield+$10-$12
db !playfield+$08-$09, !playfield+$08-$12


.legalMoves
	REP #$20

	LDX #$3E
--	STZ !playfield+$40,x
	DEX #2
	BPL --

	SEP #$20

	STZ $01		;
	STZ $03		;
	STZ $05		;high bytes of some adresses
	STZ $09		;

	STZ $0A	;number of captures available

	LDX #$00

	JSR .checkMovesCaptures

	LDA $0A	;if any capture is possible
	BNE -		;regular moves are not legal

	LDX #$02

	JMP .checkMovesCaptures

;⇖⇗↖↗
.topFlags
db %01000000, %00010000, %10000000, %00100000
;⇙⇘↙↘
.bottomFlags
db %00000100, %00000001, %00001000, %00000010

.checkMovesCaptures
	;down left
	LDA #!playfield
	STA $00
	ORA #$40
	STA $08
	LDA #!playfield+$07
	STA $02
	LDA #!playfield+$0E
	STA $04

	STZ $06
	LDA .bottomFlags,x
	STA $07

	LDA #$02
	STA $0B

	JSR (.checkMoveCapturePointers,x)

	;down right
;	LDA #!playfield
;	STA $00
	LDA #!playfield+$09
	STA $02
	LDA #!playfield+$12
	STA $04

	LDA .columnsCheck,x
	STA $06
	LDA .bottomFlags+1,x
	STA $07
	
	JSR (.checkMoveCapturePointers,x)

	;up right
	LDA .rowOffsetsNeutral,x
	STA $00
	ORA #$40
	STA $08
	LDA .rowOffsetsTopRight,x
	STA $02
	LDA .rowOffsetsTopRight+1,x
	STA $04

;	LDA #$06
;	STA $06
	LDA .topFlags+1,x
	STA $07

	STZ $0B
	
	JSR (.checkMoveCapturePointers,x)

	;up left
;	LDA #!playfield+$10
;	STA $00
	LDA .rowOffsetsTopLeft,x
	STA $02
	LDA .rowOffsetsTopLeft+1,x
	STA $04

	STZ $06
	LDA .topFlags,x
	STA $07

	JMP (.checkMoveCapturePointers,x)

.checkMoveCapturePointers
dw .checkCapture, .checkMove

;y = playfield index, $00 = current position, $02 = target capture, $04 = target position
;$06 column, $07 = capture flag, $08 = current flag table position
.checkCapture
	LDY #$2F

-	LDA ($00),y
	BEQ +

	AND #%10000000		;
	ORA !currentplayer	;
	BEQ ++				;only check current player's legal moves
	CMP #%10000010		;
	BNE +				;

++	LDA ($00),y
	AND #%01000000	;if promoted
	BNE ++			;can move backwards

	LDA $0B
	EOR !currentplayer	;if moving backwards
	BNE +				;skip

++	TYA
	AND #$06
	CMP $06		;if on column 0 or 1/6 or 7
	BEQ +		;skip

	LDA ($04),y	;if target position is occupied, can't capture
	BNE +		;skip

	LDA ($02),y	;if target capture is empty, can't capture
	BEQ +		;skip

	EOR ($00),y	;if same colour, therefore uncapturable
	BPL +		;skip

	LDA ($08),y
	ORA $07
	STA ($08),y	;set can-capture flags

	INC $0A	;increment nº of captures available

+	DEY
	BPL -
	RTS

.checkMove
	LDY #$37

-	LDA ($00),y
	BEQ +

	AND #%10000000		;
	ORA !currentplayer	;
	BEQ ++				;only check current player's legal moves
	CMP #%10000010		;
	BNE +				;

++	LDA ($00),y
	AND #%01000000	;if promoted
	BNE ++			;can move backwards

	LDA $0B
	EOR !currentplayer	;if moving backwards
	BNE +				;skip

++	TYA
	AND #$07
	CMP $06		;if on column 0/7
	BEQ +		;skip

	LDA ($02),y	;if target position is occupied, can't move
	BNE +		;skip

	LDA ($08),y
	ORA $07
	STA ($08),y	;set can-capture flags

	INC $0A	;increment nº of moves available

+	DEY
	BPL -
	RTS

;.checkTerminal
;	LDA $0A
;	BNE +
;+	RTS

.capturedXPositions
db $20
.capturedYPositions
db $A0-($0B*$04), $D0, $A0-($17*$04)

.moveChecker
	LDY !tilemaptimer
	CPY #$20
	BEQ ++++

	LDA !movetype
	LSR
	BCS +	;if capturing
	TYA
	LSR
	BCS +++	;or in even animation frame

	;animate checker
+	LDA !cursorYpos
	ASL #3
	ORA !cursorXpos
	TAX

	LDA !playfield,x
	AND #%00011111
	ASL #2
	TAX

	LDA !currentselection
	AND #%00000111
	CMP !cursorXpos
	BCS +
	;right
	INC !OAM+$10,x
	BRA ++
	;left
+	DEC !OAM+$10,x

++	LDA !currentselection
	AND #%00111000
	LSR #3
	CMP !cursorYpos
	BCS +
	;down
	INC !OAM+$11,x
	BRA ++
	;up
+	DEC !OAM+$11,x

++	LDA !OAM+$12,x
	AND #%11011111
	STA !OAM+$12,x

+++	INC !tilemaptimer
	RTS

++++
	LDA !movetype
	LSR
	BCC ++

	;capture
	LDX !currentplayer
	LDY !capturedidx1,x

	LDA .capturedXPositions,x
	STA !OAM+$70,y

	LDA !captureposition
	AND #%00011111
	ASL #2
	TAX

	LDA !OAM+$12,x
	STA !OAM+$72,y
	LDA !OAM+$13,x
	STA !OAM+$73,y

	STZ !OAM+$10,x
	STZ !OAM+$11,x
	STZ !OAM+$12,x
	STZ !OAM+$13,x

	LDX !currentplayer
	TYA
	ADC .capturedYPositions,x
	STA !OAM+$71,y

	TYA
	SEC
	SBC #$04
	STA !capturedidx1,x

	JSR .legalMoves

	LDA !cursorYpos
	ASL #3
	ORA !cursorXpos
	TAX

	LDA !playfield+$40,x
	BIT #%01010101
	BEQ ++

	TXY

	REP #$20

	LDX #$3E
-	STZ !playfield+$40,x
	DEX #2
	BPL -

	SEP #$20

	STA.w !playfield+$40,y
	INC !chaincapture

	BRA +

++	LDA !currentplayer
	EOR #$02
	STA !currentplayer

	JSR .legalMoves
	LDA $0A
	BNE +

	LDA !currentplayer
	EOR #$02
	LSR
	INC
	STA !winner
	
+	LDA !cursorYpos
	ASL #3
	ORA !cursorXpos
	TAX

	LDA !playfield,x
	LDY !cursorYpos
	BEQ +
	CPY #$07
	BNE ++
+	ORA #%01000000
	STA !playfield,x

++	BIT #$40
	BEQ +

	AND #%00011111
	ASL #2
	TAX

	LDA !OAM+$12,x
	ORA #%00000010
	STA !OAM+$12,x

+	LDA #$80
	STA !currentselection

	LDA !winner
	BEQ +

	INC !updatetext
	INC !substate
	RTS

+	JSR SquareCursorInit

	DEC !substate
	RTS


.prepareCheckers
;cp1iiiii  promoted, colour, ID
	LDX #$06
	LDA #%10100000
	LDY #%00101100
	;whites
-	STA !playfield+$01,x
	INC
	STA !playfield+$08,x
	INC
	STA !playfield+$11,x
	INC
	;reds
	STY !playfield+$28,x
	INY
	STY !playfield+$31,x
	INY
	STY !playfield+$38,x
	INY

	DEX #2
	BPL -

	REP #$30

	LDX #!OAM+$12+($0B*4)
	LDA #$004C|(%00101110<<8)	;tile number, properties of white pieces
	LDY #$004C|(%00101000<<8)	;tile number, properties of red pieces

-	STA $00,x
	STY $0C*4,x
	DEX #4
	CPX #!OAM+$12
	BPL -

;	LDA #$004C|(%00101110<<8)	;tile number, properties of white pieces
;	STA !OAM+$12

;	LDX #!OAM+$12
;	LDY #!OAM+$16
;	LDA #$000C*4-3
;	MVN $00, $00	;copy for the next 12 OAM slots (1 extra to set up X & Y)

;	LDA #$004C|(%00101000<<8)	;tile number, properties of red pieces
;	STA !OAM+$42

;	LDA #$000B*4-1
;	MVN $00, $00	;copy for the next 11 OAM slots

	;size of the sprites = big (16x16)
	LDA #%1010101010101010	;high table properties, X = 0, s = 1
	STA !OAMhigh+1
	STA !OAMhigh+3
	STA !OAMhigh+5

	STA !OAMhigh+7
	STA !OAMhigh+9
	STA !OAMhigh+11

	SEP #$30

	LDX #$3F
-	LDA !playfield,x
	BEQ +
	
	AND #%00011111
	ASL #2
	TAY

	TXA
	AND #%00000111
	ASL #4
	ADC #$40
	;xpos
	STA !OAM+$10,y
	TXA
	AND #%00111000
	ASL
	ADC #$30
	;ypos
	STA !OAM+$11,y
	
+	DEX
	BPL -

	RTS

.initNMI
	LDA #$80
	STA !brightness

	LDA.b #bank(Tilemaps_checkers_tilemapBG1)
	STA $02

	REP #$20

	LDA #$1800
	STA $2116

	LDA #Tilemaps_checkers_tilemapBG1
	STA $00

	JSR LoadTilemapCompressed

	LDA #Tilemaps_tictactoe_tilemapBG2
	STA $00

	JSR LoadTilemapCompressed

;	LDA #$0800
;	JSR LoadEmptyTilemap
	LDA #$0800
	JSR LoadEmptyTilemap

	JSR OAMClear

	SEP #$20
	RTS

.NMI
	LDA !substate
	ASL
	TAX
	JMP (.NMIPointers,x)

.NMIPointers
dw FadeNMI, .tilemapDrawNMI, .mainNMI, .moveCheckerNMI, EndNMI

.moveCheckerNMI
	REP #$20

	JSR OAMUpdate

	SEP #$20

	LDA #$80	;
	STA $2103	;make the capturing checker have priority over the rest
	
	LDA !cursorYpos
	ASL #3
	ORA !cursorXpos
	TAX

	LDA !playfield,x
	AND #%00011111
	ASL

	STA $2102

	RTS

.mainNMI
	LDA !tilemaptimer
	BEQ +
	STZ !tilemaptimer
	JSR DrawCurrentPlayer

+	JSR SquareCursorUpdate

	REP #$20

	JSR OAMUpdate

	SEP #$20
	RTS

macro range(step)
	db !current
	!current #= !current+<step>
endmacro

!basex = $40
!basey = $30
.cursorYposTable
!current = !basey-$02
rep 8 : %range($10)
!current = !basey+$0A
rep 8 : %range($10)

.cursorXposTable
!current = !basex-$02
rep 8 : %range($10)
!current = !basex+$0A
rep 8 : %range($10)

.tilemapDrawNMI
	LDA !tilemaptimer
	ASL
	TAX

	REP #$31

	LDA .whiteOffsets,x
	STA $2116

	LDY #$0851
	STY $2118
	STY $2118

	ADC #$0020
	STA $2116

	STY $2118
	STY $2118

	LDA .blackOffsets,x
	STA $2116

	LDY #$0822
	STY $2118
	STY $2118

	ADC #$0020
	STA $2116

	STY $2118
	STY $2118

	SEP #$30
	RTS

!base = $1800
macro whitetiles()
	dw !base+!start
	!start #= !start+$04
endmacro

macro whitelines()
	rep 4 : %whitetiles()
	!start #= !start+$32
	rep 4 : %whitetiles()
	!start #= !start+$2E
endmacro

macro blacktiles()
	dw !base+!start
	!start #= !start-$04
endmacro

macro blacklines()
	rep 4 : %blacktiles()
	!start #= !start-$2E
	rep 4 : %blacktiles()
	!start #= !start-$32
endmacro

.whiteOffsets
!start = $00C8
rep 4 : %whitelines()
.blackOffsets
!start = $0294
rep 4 : %blacklines()
