
include

Menu:
.init
	STZ !brightness

	STZ !cursorXpos
	STZ !maxcursorXpos
;	STZ !cursorYpos
	
	LDX !menustate
	LDA .maxcursorYposTable,x
	STA !maxcursorYpos

	STZ !substate
	STZ !currentplayer
	STZ !winner

	LDA #$FF
	STA !BG3ypos

	LDA #$09
	STA !BGmode

	STZ !windowmasksettingsBG1BG2
	STZ !windowmasksettingsBG3BG4
	STZ !windowmasksettingsOBJColorWindow

	INC !gamemode
	RTS

.main
	LDA !fadeinout
	BNE +
	;fade in
	LDA !brightness
	CMP #$0F
	BCS ++
	INC !brightness
	BRA +++

	;fade out
+	LDA !brightness
	BEQ +
	DEC !brightness
	BRA +++

	;option has been selected
+	STZ !fadeinout

	LDA !cursorYpos
	INC
	ASL
	STA !gamemode
	RTS


++	LDA !mosaicinout
	BNE +
	;mosaic in
	LDA !mosaic
	CMP #$10
	BCC ++

	SBC #$10
	STA !mosaic
	BRA +++

	;mosaic out
+	LDA !mosaic
	CMP #$70
	BCS +

	ADC #$10
	STA !mosaic
	BRA +++

+	STA !mosaicinout
	BRA +++

++	LDA !menustate
	ASL
	TAX
	JSR (.menuPointers,x)

;bg2 scrolling
+++	LDA !framecounter
	LSR
	BCC +
	INC !BG2xpos
	LSR
	BCC +
	DEC !BG2ypos

+	RTS

.menuPointers
dw .titleScreen, .mainMenu, .options

.titleScreen
	LDA !controller1pressbyetUDLR
	ORA !controller2pressbyetUDLR
	BIT #$10	;start button
	BEQ +

	INC !menustate
	INC !mosaicinout
	LDA #$04
	STA !mosaic
	STZ !cursorYpos

+	RTS

!basex = $30
!basey = $40
.mainMenu
	JSR .getMenuCursorAnimationOffset

	LDX !cursorYpos
	LDA .cursorYposTableMenu,x
	XBA
	TYA

	REP #$20

	STA !OAM
	LDA #$002A|(%00100110<<8)	; cursor tile number and properties
	STA !OAM+2

	SEP #$20

	BIT !controller1pressbyetUDLR
	BPL +
	DEC !menustate
	INC !mosaicinout
	RTS
	
+	BIT !controller1pressaxlr0000
	BPL +

;option selection
	LDA !cursorYpos
	CMP !maxcursorYpos
	BEQ ++
	INC !fadeinout

+	JSR CursorUpdate
	RTS

++	INC !menustate
	INC !mosaicinout
	STZ !cursorYpos
	RTS

.cursorYposTableMenu
db !basey+$00, !basey+$10, !basey+$20, !basey+$30, !basey+$68

.options
	JSR .getMenuCursorAnimationOffset

	LDX !cursorYpos
	LDA .cursorYposTableOptions,x
	XBA
	TYA

	REP #$20

	STA !OAM
	LDA #$002A|(%00100110<<8)	; cursor tile number and properties
	STA !OAM+2

	SEP #$20

	BIT !controller1pressbyetUDLR
	BMI +

	JSR CursorUpdate
	
	BIT !controller1pressaxlr0000
	BPL ++
	LDA !cursorYpos
	ASL
	TAX
	JMP (.optionsPointers,x)

.optionsPointers
dw .changeLanguage, .turnOrder, .vsCPU, .back

.back
+	DEC !menustate
	INC !mosaicinout
	LDA .maxcursorYposTable+1
	STA !cursorYpos

	;save settings to SRAM
	LDA !language
	STA $F00001
	LDA !turnorder
	STA $F00002
	LDA !vsCPU
	STA $F00003

++	RTS

.changeLanguage
	LDA !language
	INC #2
	CMP #$06
	BCC +
	LDA #$00
+	STA !language
	INC !updatetext
	RTS
	
.turnOrder
	LDA !turnorder
	INC #2
	CMP #$06
	BCC +
	LDA #$00
+	STA !turnorder
	INC !updatetext
	RTS

.vsCPU
	LDA !vsCPU
	INC #2
	CMP #$06
	BCC +
	LDA #$00
+	STA !vsCPU
	INC !updatetext
	RTS

.cursorYposTableOptions
db !basey+$00, !basey+$20, !basey+$40, !basey+$68

.initNMI
	LDA #$80
	STA !brightness

	LDA #%10000001	;Disable IRQ
	STA $4200

	LDA.b #bank(Tilemaps_menu_tilemapBG1)
	STA $02

	STZ $420C

	REP #$20

	LDA #$1800
	STA $2116

	LDA #Tilemaps_menu_tilemapBG1
	STA $00

	JSR LoadTilemapCompressed

	LDA #$0400
	STA $00
	LDY #$02
-	LDA #Tilemaps_menu_tilemapBG2
	LDX.b #bank(Tilemaps_menu_tilemapBG2)

	JSR LoadTilemapUncompressed

	DEY
	BNE -

	LDX #$00

	JSR .loadText

	JSR OAMClear

	JSR PlayfieldClear

	SEP #$20
-	RTS

.loadText
; text
	LDA #$2000
	STA $2116
	LDA #$0800

	JSR LoadEmptyTilemap

	SEP #$20

	LDA !menustate
	ASL
	ADC !menustate
	ASL

	ADC !language
	TAX

	REP #$20

	LDA .languagePointers,x
	STA $00

	INX #2
	LDA .languagePointers,x
	SEC
	SBC $00
	STA $03

	LDX.b #bank(Tilemaps_menu_tilemapBG3)
	STX $02

	JSR LoadPartialTilemap

	LDA !menustate
	LSR #2
	BCC -

.changeOptionText
	LDA !turnorder
	ASL
	ADC !turnorder
	ADC !language
	TAX

	LDA .languagePointersOrder,x
	STA $00

	INX #2
	LDA .languagePointersOrder,x
	SEC
	SBC $00
	STA $03

	LDX.b #bank(Tilemaps_menu_tilemapBG3)
	STX $02

	JSR LoadPartialTilemap

	LDA !vsCPU
	ASL
	ADC !vsCPU
	ADC !language
	TAX

	LDA .languagePointersCPU,x
	STA $00

	INX #2
	LDA .languagePointersCPU,x
	SEC
	SBC $00
	STA $03

	LDX.b #bank(Tilemaps_menu_tilemapBG3)
	STX $02

	JMP LoadPartialTilemap

.languagePointers
dw Tilemaps_menu_tilemapBG3_titleScreen_English
dw Tilemaps_menu_tilemapBG3_titleScreen_Espanol
dw Tilemaps_menu_tilemapBG3_titleScreen_Catala

dw Tilemaps_menu_tilemapBG3_mainMenu_English
dw Tilemaps_menu_tilemapBG3_mainMenu_Espanol
dw Tilemaps_menu_tilemapBG3_mainMenu_Catala

dw Tilemaps_menu_tilemapBG3_options_English
dw Tilemaps_menu_tilemapBG3_options_Espanol
dw Tilemaps_menu_tilemapBG3_options_Catala

.languagePointersOrder
dw Tilemaps_menu_tilemapBG3_options_Order1_English
dw Tilemaps_menu_tilemapBG3_options_Order1_Espanol
dw Tilemaps_menu_tilemapBG3_options_Order1_Catala

dw Tilemaps_menu_tilemapBG3_options_Order2_English
dw Tilemaps_menu_tilemapBG3_options_Order2_Espanol
dw Tilemaps_menu_tilemapBG3_options_Order2_Catala

dw Tilemaps_menu_tilemapBG3_options_Order3_English
dw Tilemaps_menu_tilemapBG3_options_Order3_Espanol
dw Tilemaps_menu_tilemapBG3_options_Order3_Catala

.languagePointersCPU
dw Tilemaps_menu_tilemapBG3_options_CPU1_English
dw Tilemaps_menu_tilemapBG3_options_CPU1_Espanol
dw Tilemaps_menu_tilemapBG3_options_CPU1_Catala

dw Tilemaps_menu_tilemapBG3_options_CPU2_English
dw Tilemaps_menu_tilemapBG3_options_CPU2_Espanol
dw Tilemaps_menu_tilemapBG3_options_CPU2_Catala

dw Tilemaps_menu_tilemapBG3_options_CPU3_English
dw Tilemaps_menu_tilemapBG3_options_CPU3_Espanol
dw Tilemaps_menu_tilemapBG3_options_CPU3_Catala

dw Tilemaps_menu_tilemapBG3_end

.getMenuCursorAnimationOffset
	LDY #!basex
	LDA !framecounter
	ORA #$D0
	CLC
	ADC #$03
	BCS +
	ADC #$03
	BCS ++
	ADC #$03
	BCC +++

	WDM
	skip -1
++	INY
+	INY

+++ RTS

.NMI:
	LDA !mosaic
	BIT #$70
	BEQ +

	REP #$20
	JSR OAMClear
	SEP #$20

	LDA !mosaicinout
	ASL
	BPL ++
	STZ !mosaicinout

	REP #$20

	JSR .loadText

	SEP #$20

	LDX !menustate
	LDA .maxcursorYposTable,x
	STA !maxcursorYpos

++	RTS

+	LDA !menustate
	ASL
	TAX
	JMP (.menuNMIPointers,x)

.menuNMIPointers
dw .titleScreenNMI, .mainMenuNMI, .optionsNMI

.maxcursorYposTable
db $00, $04, $03

.titleScreenNMI
	LDA !framecounter
	AND #$3F
	BEQ ++
	CMP #$30
	BNE +

	REP #$20

	LDA #$2000+($15*$20)
	STA $2116

	LDA #$0040
	JSR LoadEmptyTilemap

	SEP #$20
+	RTS

++	REP #$20

	JSR .loadText

	SEP #$20
	RTS

.optionsNMI
	LDA !updatetext
	BEQ +
	STZ !updatetext

	REP #$20

	JSR .loadText
	JSR .changeOptionText

.mainMenuNMI
+	REP #$20

	JSR OAMUpdate

	SEP #$20
	RTS
