
include

GetRand:
	LDA $2137	;Latch Scanline Location

	REP #$21	;16-bit accumulator, clear carry

	LDA $213C   ;Horizontal Scanline Location, Vertical Scanline Location
	ADC $213C   ;low and high, read twice
	ADC !framecounter		;Frame counter
	ADC !controller1hold	;Controller 1
	ADC !controller2hold	;Controller 2
	ADC !randresult			;Previous random result
	ADC $01,s	;Address the routine was called from
	XBA
	STA !randresult

	SEP #$20	;8-bit accumulator
	RTS

!DAS = $12	;delayed auto shift
!ARR = $04	;auto repeat rate
CursorUpdate:
	LDY #$07
	LDX #$02
-	LDA !controller1holdbyetUDLR,x
	AND .directionMasks,y
	BEQ +

	LDA.w !directiontimer1,y
	CMP #!DAS
	BCC ++
	SBC #!ARR-1
	STA.w !directiontimer1,y

	LDA .directionMasks,y
	ORA !controller1holdaxlr0000,x
	STA !controller1holdaxlr0000,x
	BRA +++

++	INC
	STA.w !directiontimer1,y
	BRA +++

+	STA.w !directiontimer1,y
+++	DEY
	BMI +
	CPY #$03
	BNE -

	LDX #$00
	BRA -

+	LDX #$06
-	LDA !uptimer1,x
	BEQ +
	LDA !downtimer1,x
	BEQ +
	STZ !uptimer1,x
	STZ !downtimer1,x
+	DEX #2
	BPL -

	LDX #$02
	LDY !currentplayer
-	LDA !maxcursorpos,x
	BEQ +

	LDA.w !controller1pressbyetUDLR,y
	ORA.w !controller1holdaxlr0000,y
	AND .cursorButtonMasks,x	;if no direction pressed
	BEQ +						;do nothing
	CMP .cursorButtonMasks,x	;if both directions pressed
	BEQ +						;do nothing
	CMP .cursorButtonMasks+1,x
	LDA !cursorpos,x
	BCS ++
	;move right/down
	CMP !maxcursorpos,x
	BCC +++
	;acc eq or greater than data
	STZ !cursorpos,x
	BRA +
	;acc less than data
+++	INC
	STA !cursorpos,x
	BRA +

	;move left/up
++	BNE ++
	LDA !maxcursorpos,x
	WDM
	skip -1
++	DEC
	STA !cursorpos,x

+	DEX #2
	BPL -
	RTS

.cursorButtonMasks:
db %00000011, %00000010, %00001100, %00001000

.directionMasks
db $08, $04, $02, $01, $08, $04, $02, $01

FadeMain:
	LDA !fadeinout
	BNE +
	;fade in
	LDA !brightness
	CMP #$0F
	BCC ++
	INC !substate
++	RTS

	;fade out
+	LDA !brightness
	BNE +

	;option has been selected
	STZ !fadeinout
	LDA !gamemode
	LSR
	DEC
	STA !cursorYpos
	STZ !gamemode
+	RTS

FadeNMI:
	LDA !fadeinout
	BNE +
	;fade in
;	LDA !brightness
;	CMP #$0F
;	BCS ++
	INC !brightness
++	RTS

	;fade out
+;	LDA !brightness
;	BEQ +
	DEC !brightness
+	RTS


EndMain:
	LDA !controller1pressaxlr0000
	ORA !controller2pressaxlr0000
	BMI +	;A button

	LDA !controller1pressbyetUDLR
	ORA !controller2pressbyetUDLR
	BIT #%10010000	;Start or B button
	BEQ ++

+	INC !fadeinout
	STZ !substate
++	RTS

EndNMI:
	LDA !updatetext
	BEQ ++
	STZ !updatetext

	REP #$20

	LDA #$2000
	STA $2116
	LDA #$0040

	JSR LoadEmptyTilemap
	JSR OAMUpdate

	SEP #$20

	LDA !winner
	ASL
	ADC !winner
	ASL
	ADC #$06
	
	BRA +

DrawCurrentPlayer:
	LDA !currentplayer
	ASL
	ADC !currentplayer
+	ADC !language
	TAX

	REP #$20

	LDA LanguagePointers1,x
	STA $00

	INX #2
	LDA LanguagePointers1,x
	SEC
	SBC $00
	STA $03

	LDX.b #bank(Tilemaps_generic_tilemapBG3)
	STX $02

	JSR LoadPartialTilemap

	SEP #$20
++	RTS

LanguagePointers1:
dw Tilemaps_generic_tilemapBG3_English1
dw Tilemaps_generic_tilemapBG3_Espanol1
dw Tilemaps_generic_tilemapBG3_Catala1

dw Tilemaps_generic_tilemapBG3_English2
dw Tilemaps_generic_tilemapBG3_Espanol2
dw Tilemaps_generic_tilemapBG3_Catala2

dw Tilemaps_generic_tilemapBG3_EnglishEnd1
dw Tilemaps_generic_tilemapBG3_EspanolEnd1
dw Tilemaps_generic_tilemapBG3_CatalaEnd1

dw Tilemaps_generic_tilemapBG3_EnglishEnd2
dw Tilemaps_generic_tilemapBG3_EspanolEnd2
dw Tilemaps_generic_tilemapBG3_CatalaEnd2

dw Tilemaps_generic_tilemapBG3_EnglishEnd3
dw Tilemaps_generic_tilemapBG3_EspanolEnd3
dw Tilemaps_generic_tilemapBG3_CatalaEnd3

dw Tilemaps_generic_tilemapBG3_EnglishRound
dw Tilemaps_generic_tilemapBG3_EspanolRound
dw Tilemaps_generic_tilemapBG3_CatalaRound

dw Tilemaps_generic_tilemapBG3_end

SquareCursorUpdate:
;animation
	LDX #$00
	LDA !framecounter
	ORA #$E0
	CLC
	ADC #$03
	BCS +
	ADC #$03
	BCS ++
	ADC #$03
	BCC +++

	WDM
	skip -1
++	INX
+	INX

+++	STX $00

;OAM data
	LDY !cursorYpos

	TXA
	CLC
	ADC (!cursorpostable),y

	STA !OAM+1
	STA !OAM+5

	LDA (!cursorpostable+2),y
	SEC
	SBC $00

	STA !OAM+9
	STA !OAM+13

	LDY !cursorXpos

	TXA
	CLC
	ADC (!cursorpostable+4),y

	STA !OAM
	STA !OAM+8

	LDA (!cursorpostable+6),y
	SEC
	SBC $00

	STA !OAM+4
	STA !OAM+12

	RTS

SquareCursorInit:
	LDX !currentplayer
	LDA #%00100000	; cursor properties
	ORA !cursorpalettes,x
	STA !OAM+3

	LDA #%01100000
	ORA !cursorpalettes,x
	STA !OAM+7

	LDA #%10100000
	ORA !cursorpalettes,x
	STA !OAM+11

	LDA #%11100000
	ORA !cursorpalettes,x
	STA !OAM+15

	LDA #$2B	; cursor tile number
	STA !OAM+2
	STA !OAM+6
	STA !OAM+10
	STA !OAM+14

	RTS

SquareCursorClear:
	REP #$20

	LDX #$0E
-	STZ !OAM,x
	DEX #2
	BPL -

	SEP #$20
	RTS
