
include
	
NMI:
	REP #$30
	PHA
	PHX
	PHY
	SEP #$30

	LDA #$80
	STA $2100
	LDA !gamemode
	ASL
	TAX
	JSR (GamemodeNMIPointers,x)
;	JSR RegistersUpdate
;	JSR ControllerUpdate
RegistersUpdate:
	LDX #$0A
	LDY #$05
	;$12-$1D
-	LDA $12,x
	STA $210D,y
	LDA $12+1,x
	STA $210D,y
	DEX #2
	DEY
	BPL -
	
	REP #$20

	LDA $31
	STA $2105

	LDX #$04
	;$34-$39
-	LDA $34,x
	STA $2124,x
	DEX #2
	BPL -

	LDA $3C
	STA $212C
	LDA $3E
	STA $212E

	SEP #$20

	LDA $33
	STA $2123

	LDA $2D
	STA $2100

;	RTS

ControllerUpdate:
-	LDA $4212		; check if Auto-Joypad read finished 
	LSR
	BCS -

	LDA $4017	;check if controller port 2 has something connected
	AND #$01
	ASL
	TAY

	REP #$20

	LDX #$02

-	LDA $20,x
	EOR #$FFFF
	AND $4218,y
	STA $24,x

	LDA $4218,y
	BIT #$000F
	BEQ +
	LDA #$0000
+	STA $20,x

	DEX
	BMI +
	DEX

	LDA $4016	;check if controller port 1 has something connected
	LSR
	BCC -
	LDY #$00
	BRA -

+	;SEP #$20
	REP #$30
	PLY
	PLX
	PLA
	SEP #$30

	INC !framefinished
;IRQ:
	RTI

!channel = $10
LoadEmptyTilemap:
	STA $4305|!channel				; DMA Size for Channel 1

	LDA #EmptyData
	STA $4302|!channel				; DMA Source Address for Channel 1 low byte, high byte
	LDX.b #bank(EmptyData)
	STX $4304|!channel				; DMA Source Address for Channel 1 bank byte

	LDX #%00000010			; channel 1
	STX $420B				; DMA Enable

	RTS

!channel = $20
LoadTilemapUncompressed:
	STA $4302|!channel				; DMA Source Address for Channel 2 low byte, high byte
	STX.b $4304|!channel				; DMA Source Address for Channel 2 bank byte

	LDA $00		; Transfer all tileset data
	STA $4305|!channel				; DMA Size for Channel 2
	
	LDX #%00000100			; channel 2
	STX $420B				; DMA Enable

	RTS

LoadTilemapCompressed:
	LDY #$00
--	REP #$30
	LDA [$00],y				; read header
	BPL +
	; repeat on
	AND #$7FFF
	LSR
	TAX
	INY #2

	LDA [$00],y
-	STA $2118
	DEX
	BNE -
	INY #2
	BRA --

+	BEQ ++
	; repeat off
	LSR
	TAX
	INY #2
	BCC +
	; set attributes per tile
-	LDA [$00],y
	STA $2118
	INY #2
	DEX
	BNE -

	BRA --

	; all tiles share attributes
+	SEP #$20
	
	LDA [$00],y		; read attr
	XBA
	INY

-	LDA [$00],y
	REP #$20
	STA $2118
	SEP #$20
	INY
	DEX
	BNE -

	BRA --

	; end of data
++	SEP #$10
	RTS

LoadPartialTilemap:
	LDY #$00
--	REP #$31
	LDA [$00],y

	ADC #$2000
	STA $2116
	INY #2

	LDA [$00],y
	XBA
	INY

-	REP #$20
	STA $2118
	SEP #$20

	INY
	LDA [$00],y
	BNE -

	INY
	CPY $03
	BNE --

	SEP #$10
	REP #$20
	RTS

; OAM
OAMClear:
!channel = $00
; DMA Channel 0
	LDA #!OAM
	STA $2181				; WRAM Address low byte, high byte

	LDA #$0220
	STA $4305|!channel				; DMA Size for Channel 0 low byte, $0220 bytes

	LDX #%00000001
	STX $420B

OAMUpdate:
!channel = $30
	STZ $2102

	LDA #$0400|%00000000	;
	STA $4300|!channel
	LDA #!OAM
	STA $4302|!channel
	LDX #$7E
	STX $4304|!channel
	LDA #$0220	; OAM size
	STA $4305|!channel

	LDX #%00001000	;
	STX $420B

	RTS

PlayfieldClear:
!channel = $00
; DMA Channel 0
	LDA.w #!playfield
	STA $2181				; WRAM Address low byte, high byte

	LDA #$0080
	STA $4305|!channel				; DMA Size for Channel 0 low byte, $0220 bytes

	LDX #%00000001
	STX $420B

	RTS

GamemodeNMIPointers:
dw Menu_initNMI, Menu_NMI
dw TicTacToe_initNMI, TicTacToe_NMI
dw Checkers_initNMI, Checkers_NMI
dw Yacht_initNMI, Yacht_NMI
dw TileCount_initNMI, TileCount_NMI
