
include
	
TicTacToe:
.init
	STZ !brightness
	STZ !tilemaptimer

	REP #$20

	STZ !BG2xpos
	LDA #$000F
	STA !BG2ypos

	LDA #$00DF
	STA !BG3ypos

	LDA #$0200
	STA !cursorXpos
	STA !cursorYpos

	LDA #.cursorYposTable
	STA !cursorpostable
	LDA #.cursorYposTable+3
	STA !cursorpostable+2

	LDA #.cursorXposTable
	STA !cursorpostable+4
	LDA #.cursorXposTable+3
	STA !cursorpostable+6

	SEP #$20

	LDA #%00000110
	STA !cursorpalette1
	LDA #%00001000
	STA !cursorpalette2

	LDA !turnorder
	CMP #$04
	BCC +
	JSR GetRand
	AND #$02
+	STA !currentplayer

	JSR SquareCursorInit

	INC !gamemode
	STZ !substate
	RTS

.main
	LDX #$02
-	LDA !controller1holdbyetUDLR,x
	BIT #$10
	BEQ +
	LDA !backtimer1,x
	INC
	STA !backtimer1,x
	CMP #$3C
	BNE ++
	INC !fadeinout
	STZ !substate
	RTS

+	STZ !backtimer1,x
++	DEX #2
	BPL -

	LDA !substate
	ASL
	TAX
	JMP (.MainPointers,x)

.MainPointers
dw FadeMain, .tilemapDrawMain, .mainMain, .drawOXMain, EndMain

.tilemapDrawMain
	LDA !tilemaptimer
	CMP #$1D
	BEQ +
	INC !tilemaptimer
	RTS

+	;STZ !tilemaptimer
	INC !substate
	RTS

.mainMain
	JSR CursorUpdate

	LDA !vsCPU
	BEQ +
	LDA !currentplayer
	BEQ +
;	LDA !controller2holdbyetUDLR
;	BIT #$20
;	BEQ +

	JSR TicTacToeGetMove

+	LDX !currentplayer
	BIT !controller1pressaxlr0000,x
	BPL +
	LDA !cursorYpos
	ASL #2
	ADC !cursorXpos
	TAX

	LDA !playfield,x
	BNE +

	LDA !currentplayer
	LSR
	INC
	STA !playfield,x

	JSR .checkTerminal

	JSR SquareCursorClear

	INC !substate
+	RTS

.checkTerminal
;columns
	LDX #$02
-	LDA !playfield,x
	AND !playfield+4,x
	AND !playfield+8,x

	BEQ +
	STA !winner
	RTS

+	DEX
	BPL -

;rows
	LDX #$08
-	LDA !playfield,x
	AND !playfield+1,x
	AND !playfield+2,x

	BEQ +
	STA !winner
	RTS

+	DEX #4
	BPL -

;TLBR
	LDA !playfield
	AND !playfield+5
	AND !playfield+10

	BEQ +
	STA !winner
	RTS

;BLTR
+	LDA !playfield+2
	AND !playfield+5
	AND !playfield+8

	BEQ +
	STA !winner
	RTS

+	LDX #$02
-	LDA !playfield,x
	BEQ +
	LDA !playfield+4,x
	BEQ +
	LDA !playfield+8,x
	BEQ +
	DEX
	BPL -

	LDA #$03
	STA !winner

+	RTS

.drawOXMain
	LDA !tilemaptimer
	CMP #$18
	BEQ +
	INC !tilemaptimer
	RTS

+	LDA !winner
	BEQ +

	INC !substate
	INC !updatetext
	RTS

+	DEC !substate
	LDA !currentplayer
	EOR #$02
	STA !currentplayer

	JSR SquareCursorInit

	RTS

.initNMI
	LDA #$80
	STA !brightness

	LDA.b #bank(Tilemaps_tictactoe_tilemapBG1)
	STA $02

	REP #$20

	LDA #$1800
	STA $2116

	LDA #Tilemaps_tictactoe_tilemapBG1
	STA $00

	JSR LoadTilemapCompressed

	LDA #Tilemaps_tictactoe_tilemapBG2
	STA $00

	JSR LoadTilemapCompressed

	LDA #$0800
	JSR LoadEmptyTilemap

	JSR OAMClear

	SEP #$20
	RTS

.NMI
	LDA !substate
	ASL
	TAX
	JMP (.NMIPointers,x)

.NMIPointers
dw FadeNMI, .tilemapDrawNMI, .mainNMI, .drawOXNMI, EndNMI

!defaultProperties = $1C
.drawOXNMI
	LDA !tilemaptimer
	CMP #$0C
	BCS ++

	TAY

	BNE +

	REP #$20
	JSR OAMUpdate
	SEP #$20

+	LDA !cursorYpos	;
	ASL
	ADC !cursorYpos	; 
	ADC !cursorXpos	; cursorYpos * 3 + cursorXpos = Index to the table
	ASL				;
	TAX

	LDA !currentplayer
	BEQ .drawX

.drawO
	REP #$21

	LDA .OPos,y
	AND #$00FF
	ADC .OXBasePositions,x
	STA $2116

	SEP #$20

	LDA .OTiles,y
	STA $2118
	LDA #!defaultProperties	; properties
	STA $2119

++	RTS

.drawX
	CPY #$04
	BCC +
	CPY #$08
	BCC ++

+	REP #$21

	LDA .XPos,y
	AND #$00FF
	ADC .OXBasePositions,x
	STA $2116

	SEP #$20

	LDA .XTiles1,y
	STA $2118
	LDA .XProperties1,y
	STA $2119

	LDA .XTiles2,y
	STA $2118
	LDA .XProperties2,y
	STA $2119

	CPY #$01
	BEQ +
	CPY #$02
	BNE ++

+	LDA .XTiles3-1,y
	STA $2118
	LDA #!defaultProperties	; properties
	STA $2119

++	RTS


.OTiles
db $16, $05, $15, $25, $35, $26
db $36, $37, $27, $17, $07, $06
.OPos
db $01, $00, $20, $40, $60, $61
db $62, $63, $43, $23, $03, $02

.XTiles1
db $45, $46, $57, $76, $00, $00
db $00, $00, $75, $57, $56, $67
.XTiles2
db $76, $55, $66, $77, $00, $00
db $00, $00, $57, $65, $76, $47
.XTiles3
db $57, $67

!xflip = $40
!yflip = $80
.XProperties1
db !defaultProperties, !defaultProperties, !defaultProperties|!xflip|!yflip, !defaultProperties, $00, $00
db $00, $00, !defaultProperties, !defaultProperties|!xflip, !defaultProperties, !defaultProperties|!xflip
.XProperties2
db !defaultProperties|!xflip|!yflip, !defaultProperties, !defaultProperties|!xflip|!yflip, !defaultProperties, $00, $00
db $00, $00, !defaultProperties|!yflip, !defaultProperties, !defaultProperties|!xflip, !defaultProperties

.XPos
db $00, $20, $41, $62, $00, $00
db $00, $00, $60, $40, $22, $02

!OXbasePosition = $18E9
!OXxoffset = $05
!OXyoffset = $A0

macro getOXbasePosition(xpos, ypos)
dw !OXbasePosition+(!OXxoffset*<xpos>)+(!OXyoffset*<ypos>)
endmacro

.OXBasePositions
%getOXbasePosition(0, 0) : %getOXbasePosition(1, 0) : %getOXbasePosition(2, 0)
%getOXbasePosition(0, 1) : %getOXbasePosition(1, 1) : %getOXbasePosition(2, 1)
%getOXbasePosition(0, 2) : %getOXbasePosition(1, 2) : %getOXbasePosition(2, 2)

.mainNMI
	LDA !tilemaptimer
	BEQ +
	STZ !tilemaptimer
	JSR DrawCurrentPlayer

+	JSR SquareCursorUpdate

	REP #$20

	JSR OAMUpdate

	SEP #$20
	RTS

!basex = $48
!basey = $38
.cursorYposTable
db !basey+$00, !basey+$28, !basey+$50
db !basey+$18, !basey+$40, !basey+$68
.cursorXposTable
db !basex+$00, !basex+$28, !basex+$50
db !basex+$18, !basex+$40, !basex+$68

.tilemapDrawNMI
	LDA #$1C
	XBA

	LDX #$00
-	LDA !tilemaptimer
	SEC
	SBC .lineOffsets,x

	JSR .drawLine

	INX
	CPX #$04
	BMI -

	RTS

.lineOffsets
db $00, $05, $05, $0A

.drawLine
	STA $4202
	LDY .multiplicand,x
	STY $4203

	CMP #$01
	BMI +++++

	BEQ +
	CMP #$10
	BEQ ++
	BPL +++++

	CPX #$02
	BCC +++
	CMP #$0B
	BEQ ++++
	CMP #$06
	BNE +++
++++
	LDA #$10
	BRA ++++

+++	AND #$01
	CLC
	ADC .gridTiles+4,x
	BRA ++++

+	LDA .gridTiles,x
	BRA ++++

++	LDA .gridTiles+8,x

++++
	REP #$10

	TAY

	LDA .basePositionsHigh,x
	XBA
	LDA .basePositionsLow,x

	REP #$20
	
	CLC
	ADC $4216
	STA $2116

	TYA

	STA $2118

	SEP #$30

+++++
	RTS

.gridTiles
db $11, $11, $01, $01
db $12, $12, $02, $02
db $14, $14, $04, $04

.multiplicand
db $20, $20, $01, $01

.basePositionsLow
db $AD, $B2, $67, $07
.basePositionsHigh
db $18, $18, $19, $1A

incsrc "tictactoeAI.asm"
