
include

TicTacToeGetMove:
	STZ $01	;
	STZ $03	;clear high byte of $00, $02, $04
	STZ $05	;

	LDA #$80
	STA !controller2pressaxlr0000	;Confirm move by the AI
	STZ !controller2pressbyetUDLR
	STZ !controller2holdaxlr0000
	STZ !controller2holdbyetUDLR

	LDY #$00

	;check win or block move
	LDX #$07
-	LDA .lineOffsets,x
	STA $00
	LDA .lineOffsets+$08,x
	STA $02
	LDA .lineOffsets+$10,x
	STA $04

	LDA ($00)
	AND ($02)
	BEQ +
	LDA ($04)
	BNE +
	;threat of 3 in a line by either player
	LDY $04		;position of considered tile
	LDA ($00)	;player threatning the win
	BRA ++

	;repeat for other combinations
+	LDA ($00)
	AND ($04)
	BEQ +
	LDA ($02)
	BNE +
	
	LDY $02
	LDA ($00)
	BRA ++

+	LDA ($02)
	AND ($04)
	BEQ ++
	LDA ($00)
	BNE +
	
	LDY $00
	LDA ($02)
	
++	CMP #$02
	BEQ ++	;if winning move found, skip ahead

+	DEX
	BPL -

++	TYA
	BEQ +
	;win or block move found
	AND #%00000011
	STA !cursorXpos
	TYA
	LSR #2
	AND #%00000011
	STA !cursorYpos
	RTS

+	LDA !vsCPU
	BIT #$02
	BEQ ++	;if on hard mode, branch to AI

	JSR GetRand

	BIT !randresult+1
	BMI ++	;easy: 50% chance to either make the best move or a random one

	LDX #$09
-	STZ $00,x
	DEX
	BPL -

	LDY #$02
	LDX #$00

-	LDA .lineOffsets,y
	STA $00,x
	LDA ($00,x)
	BNE +
	INX

+	LDA .lineOffsets+$08,y
	STA $00,x
	LDA ($00,x)
	BNE +
	INX

+	LDA .lineOffsets+$10,y
	STA $00,x
	LDA ($00,x)
	BNE +
	INX

+	DEY
	BPL -

	REP #$20

	LDA !randresult
	AND #$7FFF
;	CMP #$7FF8	;highest number smaller than $8000 capable of evenly dividing 1~9
;	BMI +

;	SEP #$20

;	JSR GetRand

;	BRA -

	STA $4204	;divident
	STX $4206	;divisor

	SEP #$20
	PHA	;
	PLA	;
	PHA	;
	PLA	;wait 16 cycles

	LDX $4216	;remainder

	LDA $00,x
	AND #%00000011
	STA !cursorXpos
	LDA $00,x
	LSR #2
	AND #%00000011
	STA !cursorYpos

	RTS

++	REP #$20

	LDX #$16
-	STZ !playfield+$0C,x
	DEX #2
	BPL -

	SEP #$20

	;create a fork
	LDX #$07
	LDY #$0C
-	LDA .lineOffsets,x
	STA $00
	LDA .lineOffsets+$08,x
	STA $02
	LDA .lineOffsets+$10,x
	STA $04

	LDA ($00)
	ORA ($02)
	BNE +
	LDA ($04)
	BEQ +
	;1 in a line by either player, rest empty
	CMP #$02
	BCC +++
	LDA #$40
	CLC

+++	PHA
	ADC ($00),y	;
	STA ($00),y	;
	PLA
	ADC ($02),y	;mark other tiles in line
	STA ($02),y	;
	BRA ++

	;repeat for other combinations
+	LDA ($00)
	ORA ($04)
	BNE +
	LDA ($02)
	BEQ +
	
	CMP #$02
	BCC +++
	LDA #$40
	CLC

+++	PHA
	ADC ($00),y
	STA ($00),y
	PLA
	ADC ($04),y
	STA ($04),y
	BRA ++

+	LDA ($02)
	ORA ($04)
	BNE ++
	LDA ($00)
	BEQ ++
	
	CMP #$02
	BCC +++
	LDA #$40
	CLC

+++	PHA
	ADC ($02),y	;
	STA ($02),y	;
	PLA
	ADC ($04),y	;mark other tiles in line
	STA ($04),y	;
	
++	DEX
	BPL -

	LDX #$0A
-	LDA !playfield+$0C,x
	BMI ++
	DEX
	
	LDA !playfield+$0C,x
	BMI ++
	DEX
	
	LDA !playfield+$0C,x
	BMI ++
	DEX #2
	
	BPL -
	BRA +

++	TXA
	AND #%00000011
	STA !cursorXpos
	TXA
	LSR #2
	AND #%00000011
	STA !cursorYpos
	RTS

	;check how many forks are available for the opponent
+	LDX #$0A
	LDY #$00
-	LDA !playfield+$0C,x
	AND #$3F
	CMP #$02
	BCC +
	INY
;	STX $00
+	DEX
	BPL -

	DEY
	BMI ++	;no forks

	BNE +++
	;one fork
	LDX #$02
-	LDY #$00
	LDA !playfield+$0C,x	;we want to play at a tile valued 2 or more for the opponent
	AND #$3F
	CMP #$02				
	BCS +
	
	INY
	LDA !playfield+$0C+4,x
	AND #$3F
	CMP #$02				
	BCS +
	
	INY
	LDA !playfield+$0C+8,x
	AND #$3F
	CMP #$02				
	BCS +

	DEX
	BPL -

++	JMP .noForks	;no good move found
	
+	STX !cursorXpos
	STY !cursorYpos
	RTS

	;block multiple forks
+++	LDX #$02
-	LDY #$00
	LDA !playfield+$0C,x	;
	LSR						;we want to force the oponent to a tile valued 40 or 41
	CMP #$20				;
	BNE +

	INC !playfield+$18,x
	
+	INY
	LDA !playfield+$0C+4,x
	LSR
	CMP #$20
	BNE +

	INC !playfield+$18+4,x
	
+	INY
	LDA !playfield+$0C+8,x
	LSR
	CMP #$20
	BNE +

	INC !playfield+$18+8,x
	
+	DEX
	BPL -

	LDX #$07
	LDY #$18
-	LDA .lineOffsets,x
	STA $00
	LDA .lineOffsets+$08,x
	STA $02
	LDA .lineOffsets+$10,x
	STA $04


	LDA ($04),y
	BEQ +

	LDA ($00)
	BEQ ++
	CMP #$02
	BNE +++

	LDA ($02)
	BNE +++

	LDA #$80
	STA ($02),y
	BRA +++

++	LDA ($02)
	CMP #$02
	BNE +++

	LDA #$80
	STA ($00),y
	BRA +++


+	LDA ($02),y
	BEQ +

	LDA ($00)
	BEQ ++
	CMP #$02
	BNE +++

	LDA ($04)
	BNE +++

	LDA #$80
	STA ($04),y
	BRA +++

++	LDA ($04)
	CMP #$02
	BNE +++

	LDA #$80
	STA ($00),y
	BRA +++


+	LDA ($00),y
	BEQ +++

	LDA ($04)
	BEQ ++
	CMP #$02
	BNE +++

	LDA ($02)
	BNE +++

	LDA #$80
	STA ($02),y
	BRA +++

++	LDA ($02)
	CMP #$02
	BNE +++

	LDA #$80
	STA ($04),y


+++	DEX
	BPL -

	LDA #$01

	;out of all possibilities, check center first
	LDX !playfield+$18+5
	BPL +
	STA !cursorXpos
	STA !cursorYpos
	RTS	

	;then corners
+	LDX !playfield+$18+0
	BPL +
	STZ !cursorXpos
	STZ !cursorYpos
	RTS	

+	LDX !playfield+$18+2
	BPL +
	INC
	STA !cursorXpos
	STZ !cursorYpos
	RTS	

+	LDX !playfield+$18+8
	BPL +
	INC
	STZ !cursorXpos
	STA !cursorYpos
	RTS	

+	LDX !playfield+$18+10
	BPL +
	INC
	STA !cursorXpos
	STA !cursorYpos
	RTS	

	;then edges
+	LDX !playfield+$18+1
	BPL +
	STA !cursorXpos
	STZ !cursorYpos
	RTS	

+	LDX !playfield+$18+4
	BPL +
	STZ !cursorXpos
	STA !cursorYpos
	RTS	

+	LDX !playfield+$18+6
	BPL +
	STA !cursorYpos
	INC
	STA !cursorXpos
	RTS	

+	LDX !playfield+$18+9
	BPL .noForks
	STA !cursorXpos
	INC
	STA !cursorYpos
	RTS

.noForks
	;prioritize center
	LDA !playfield+5
	BNE +
	INC
	STA !cursorXpos
	STA !cursorYpos
	RTS

	;then opposite corner
+	LDA !playfield
	CMP #$01
	BNE +
	LDA !playfield+10
	BNE ++
---	LDA #$02
	STA !cursorXpos
	STA !cursorYpos
	RTS

+	LDA !playfield+10
++	CMP #$01
	BNE +
	LDA !playfield
	BNE +
+++
-	STZ !cursorXpos
	STZ !cursorYpos
	RTS

+	LDA !playfield+2
	CMP #$01
	BNE +
	LDA !playfield+8
	BNE +
--	LDA #$02
	STZ !cursorXpos
	STA !cursorYpos
	RTS

	;then any corner
+	LDA !playfield+2
	BNE +
	LDA #$02
	STA !cursorXpos
	STZ !cursorYpos
	RTS

+	LDA !playfield
	BEQ -
	LDA !playfield+8
	BEQ --
	LDA !playfield+10
	BEQ ---

	;then any edge
	LDA !playfield+1
	BNE +
	INC
	STA !cursorXpos
	STZ !cursorYpos
	RTS
	
+	LDA !playfield+4
	BNE +
	INC
	STZ !cursorXpos
	STA !cursorYpos
	RTS
	
+	LDA !playfield+6
	BNE +
	INC
	STA !cursorYpos
	INC
	STA !cursorXpos
	RTS
	
+	LDA !playfield+9
	BNE +
	INC
	STA !cursorXpos
	INC
	STA !cursorYpos
+	RTS
	

.lineOffsets
db !playfield+0, !playfield+4, !playfield+8, !playfield+0, !playfield+1, !playfield+2, !playfield+0, !playfield+2
db !playfield+1, !playfield+5, !playfield+9, !playfield+4, !playfield+5, !playfield+6, !playfield+5, !playfield+5
db !playfield+2, !playfield+6, !playfield+10, !playfield+8, !playfield+9, !playfield+10, !playfield+10, !playfield+8

;rows
;%lineOffsetGenerator(0, 1, 2)
;%lineOffsetGenerator(4, 5, 6)
;%lineOffsetGenerator(8, 9, 10)

;columns
;%lineOffsetGenerator(0, 4, 8)
;%lineOffsetGenerator(1, 5, 9)
;%lineOffsetGenerator(2, 6, 10)

;diagonals
;%lineOffsetGenerator(0, 5, 10)
;%lineOffsetGenerator(2, 5, 8)
