
include
	
TileCount:
.init
	STZ !brightness
	STZ !tilemaptimer

	REP #$20

	STZ !BG2xpos
	LDA #$000F
	STA !BG2ypos
	STZ !BG3ypos

	SEP #$20

	LDA #$02
	STA !BGmode

	STZ !roundnumber

	LDA #$0A
	STA !currentplayer

	INC !gamemode
	STZ !substate
	RTS

.main
	LDX #$02
-	LDA !controller1holdbyetUDLR,x
	BIT #$10
	BEQ +
	LDA !backtimer1,x
	INC
	STA !backtimer1,x
	CMP #$3C
	BNE ++
	INC !fadeinout
	STZ !substate
	RTS

+	STZ !backtimer1,x
++	DEX #2
	BPL -

	LDA !vsCPU
	BEQ +
	;ignore all input from P2, except Start, select, L and R
	LDA #%11001111
	TRB !controller2pressbyetUDLR
	TRB !controller2pressaxlr0000
	TRB !controller2holdaxlr0000
	TRB !controller2holdbyetUDLR

+	LDA !substate
	ASL
	TAX
	JMP (.MainPointers,x)

.MainPointers
dw FadeMain, .tilemapDrawMain, .mainMain, EndMain

.tilemapDrawMain
	LDA !tilemaptimer
	BEQ ++
	CMP #$28
	BNE +

	INC !substate
	RTS
	
++	LDA !roundnumber
	CMP #$10
	BCS ++

	JSR GetRand

	AND #$06
	STA !correcttile
	
	JSR .setPossibleTiles
	JSR .setGrid
	JSR .randomizeGrid

+	INC !tilemaptimer
	RTS

	;set winner
++	LDX #$02
	LDA !playfield+$40	;P1's score
	CMP !playfield+$41	;compare to P2's score

	BCC +++	;P2 wins
	BNE ++	;P1 wins
	;draw
	INX
	WDM
	skip -1
	
++	DEX
+++	STX !winner

	INC !tilemaptimer
	RTS
	
.setPossibleTiles
	LDX #$0E
-	STX $01

---	JSR GetRand

	AND #$03
	TAY
	LDA .gridPalettes,y

	XBA
	AND #$13
	ORA #$2C
;	TAY
;	LDA .gridTiles,y

	REP #$20

	LDX #$0E
--	CPX $01
	BEQ +

	CMP !currenttiles,x
	BEQ ---
	DEX #2
	BRA --

+	STA !currenttiles,x
	
	SEP #$20

	DEX #2
	BPL -
	RTS

;.gridTiles
;db $2C, $2D, $3C, $3D
.gridPalettes
db 3<<2, 5<<2, 6<<2, 7<<2

.setGrid
	;set up the grid
	LDY !roundnumber
	LDX .roundColorNumber,y
	LDY #!playfield+2
	
	REP #$30

	LDA !currenttiles
	STA !playfield

-	LDA !currenttiles,x
	STA !playfield+2,x
	INY #2
	DEX #2
	BPL -

	LDX.w #!playfield+2
	LDA #$002D
	MVN $00, $00

	SEP #$30
	RTS

.randomizeGrid
	LDX #$30
	LDY #$32

-	JSR GetRand
	
	REP #$20

	STA $4204	;divident
	STY $4206	;divisor

	PHA	;
	PLA	;
	PHX	;
	PLX	;wait 16 cycles

	LDA $4216	;remainder
	AND #$00FE
	TAY

	LDA !playfield,x
	PHA
	LDA.w !playfield,y
	STA !playfield,x
	PLA
	STA.w !playfield,y

	SEP #$20

	TXY
	DEX #2
	BPL -

	RTS

.mainMain
	RTS

.initNMI
	LDA #$80
	STA !brightness

	LDA.b #bank(Tilemaps_tilecount_tilemapBG1)
	STA $02

	REP #$20

	LDA #$1800
	STA $2116

	LDA #Tilemaps_tilecount_tilemapBG1
	STA $00

	JSR LoadTilemapCompressed

	LDA #Tilemaps_tictactoe_tilemapBG2
	STA $00

	JSR LoadTilemapCompressed

	LDA #$0880
	JSR LoadEmptyTilemap

	JSR OAMClear

	JSR .initHDMA

	LDA #$208C
	STA $2116
	LDA #$3830
	STA $2118

	LDA #$2093
	STA $2116
	LDA #$3830
	STA $2118

	LDA #$00A1
	STA $4209	;V Timer for IRQ

	SEP #$20

	LDA.b #!tilemapstart>>9+12
	STA $2109

	;n-yx---a
	LDA #%10100001	;IRQ Enable
	STA $4200

	RTS

.initHDMA
!channel = $40
	LDX #%00000010
	STX $4300|!channel
	LDA #!HDMA
	STA $4302|!channel
	LDX.b #bank(!HDMA)
	STX $4304|!channel

!channel = $50
	LDA #$2A00
	STA $4300|!channel
	LDA #.hdmaTable
	STA $4302|!channel
	LDX.b #bank(.hdmaTable)
	STX $4304|!channel

!channel = $60
	LDA #$2300
	STA $4300|!channel
	LDA #$2500
	STA $4300|(!channel+$10)
	LDA #.endHdmaTable
	STA $4302|!channel
	STA $4302|(!channel+$10)
	LDX.b #bank(.endHdmaTable)
	STX $4304|!channel
	STX $4304|(!channel+$10)

	RTS

.hdmaTable
db $20, %00000000
db $20, %00000011
db $20, %00000000
db $20, %00000011
db $01, %00000000
db $00

.endHdmaTable
db $70, %00000000
db $43, %00000000
db $0A, %00100010
db $01, %00000000
db $00

.NMI
	LDA.b #!tilemapstart>>9+12
	STA $2109

	LDA !substate
	ASL
	TAX
	JMP (.NMIPointers,x)

.NMIPointers
dw FadeNMI, .tilemapDrawNMI, .mainNMI, EndNMI

.mainNMI
	LDA !tilemaptimer
	BEQ ++
	STZ !tilemaptimer

--	RTS

++	LDA !roundnumber
	ASL
	TAX
	JSR (.behaviourPointers,x)
	
	LDX #$02
-	STZ $00,x

	BIT !controller1pressaxlr0000,x
	BVC +
	INC $00,x	;X button

+	LDA !controller1pressbyetUDLR,x
	ASL
	ROL $00,x	;B button
	ASL
	ROL $00,x	;Y button

	LDA !controller1pressaxlr0000,x
	ASL
	ROL $00,x	;A button

	LDA !controller1pressbyetUDLR,x
	AND #$0F
	ORA $00,x
	STA $00,x

	DEX #2
	BPL -

	ORA $02
	BEQ --	;if no buttons pressed by either player, return

	LDA !correcttile
	LSR
	TAY
	LDX #$02

-	STZ $01,x
	LDA $00,x
	BEQ +
	CMP .correctTileMasks,y
	BNE ++
	INC $01,x
	BRA +

++	DEC $01,x
+	DEX #2
	BPL -

	LDY #$38
	LDA $01
	CMP $03
	BEQ +
	BMI ++
	;P1 wins round
	LDA !playfield+$40
	INC
	STA !playfield+$40

	LDX #$8C
	STX $2116
	LDX #$20
	STX $2117

	CMP #$0A
	BCC +++

	SBC #$0A
	CLC

	LDX #$31
	STX $2118
	STY $2119

+++	ADC #$30
	STA $2118
	STY $2119
	BRA +

	;P2 wins round
++	LDA !playfield+$41
	INC
	STA !playfield+$41

	LDX #$92
	STX $2116
	LDX #$20
	STX $2117

	CMP #$0A
	BCC ++

	SBC #$0A
	CLC

	LDX #$31
	BRA +++

++	LDX #$00
+++	STX $2118
	STY $2119

	ADC #$30
	STA $2118
	STY $2119

+	REP #$20

	JSR .displayCorrect

	JSR OAMUpdate

	SEP #$20

	DEC !substate
	INC !roundnumber
	RTS

.correctTileMasks
db $01, $02, $04, $08

.buttonOAMPositions
dw $C048	;right
dw $C028	;left
dw $D038	;down
dw $B038	;up
.buttonOAMOffsets
dw $0000, $0080

.displayCorrect
	LDA #!OAM
	STA $04

	LDX #$02
--	LDY #$00
-	LSR $00,x
	BCC +++

	LDA .buttonOAMPositions,y
	ORA .buttonOAMOffsets,x
	STA ($04)

	INC $04
	INC $04

	CPY !correcttile
	BNE +
	;tick tiles
	LDA #$0068|(%00101010<<8)
	BRA ++
	;cross tiles
+	LDA #$006A|(%00101000<<8)
++	STA ($04)
	
	INC $04
	INC $04

+++	INY #2
	CPY #$08
	BCC -

	DEX #2
	BPL --

	LDA $04
	SEC
	SBC #!OAM
	LSR #2
	TAX
	DEX

	LDA #$0000
-	SEC
	ROL
	ASL
	DEX
	BPL -

	STA !OAMhigh

	RTS

.roundColorNumber
db $02, $04, $06, $04
db $04, $04, $06, $0C
db $06, $04, $06, $08
db $0A, $04, $06, $00

.behaviourInitPointers
dw .nothing, .nothing, .nothing, .verticalShiftInit
dw .verticalShiftInit, .horizontalShiftInit, .horizontalShiftInit, .nothing
dw .columnsDisjoinInit, .rowsDisjoinInit, .doubleDisjoinInit, .mixedInit
dw .flatInit, .windowSlideInit, .mixed2Init, .nothing
.behaviourPointers
dw .nothing, .nothing, .nothing, .nothing
dw .verticalShiftUpdate, .nothing, .horizontalShiftUpdate, .nothing
dw .nothing, .nothing, .nothing, .nothing
dw .nothing, .windowSlideUpdate, .windowSlideUpdate, .nothing

.nothing
	RTS

.flatInit
!channel = $40
	LDA #$0E
	STA $4301|!channel

	LDA #$27
	STA !HDMA
	STZ !HDMA+1
	STZ !HDMA+2

	LDA #$1F
	STA !HDMA+3
	LDA #$E6
	STA !HDMA+4
	STZ !HDMA+5

	LDX #$00
	LDY #$04
	XBA
	LDA #$06

-	STA !HDMA+6,x
	XBA

	CLC
	ADC #$0A
	STA !HDMA+7,x
	STZ !HDMA+8,x
	XBA

	INX #3
	DEY
	BPL -

	STZ !HDMA+21

	LDA #%00010000
	STA $420C

	RTS

.mixed2Init
	JSR .rowsDisjoinInit
	LDA #%00110000
	STA $420C

.windowSlideInit
	JSR GetRand

	AND #$3F
	STA !window1leftpos
	CLC
	ADC #$28
	STA !window1rightpos

	ADC #$28
	STA !window2leftpos
	ADC #$28
	STA !window2rightpos

	LDA #%00001010
	STA !windowmasksettingsBG1BG2

	RTS

.windowSlideUpdate
	LDX #$02
-	LDA !window1leftpos,x
	CMP #$A8
	BCC +
	LDA #$08
+	INC
	STA !window1leftpos,x
	CLC
	ADC #$28
	STA !window1rightpos,x

	DEX #2
	BPL -

	RTS

.doubleDisjoinInit
	JSR .rowsDisjoinInit

.columnsDisjoinInit
	LDA #$06
	STA $2116
	LDA #$24
	STA $2117

	LDY #$20
	LDX #$08

-	LDA .disjoinOffsets,x
	STA $2118
	STY $2119
	STA $2118
	STY $2119

	DEX
	BPL -

	RTS

.rowsDisjoinInit
!channel = $40
	LDA #$0E
	STA $4301|!channel

	LDX #$00
	LDY #$08

-	LDA #$10
	STA !HDMA,x
	LDA .disjoinOffsets,y
	DEC
	STA !HDMA+1,x
	STZ !HDMA+2,x

	INX #3
	DEY
	BPL -

	LDA #$18
	STA !HDMA
	STZ !HDMA+27

	LDA #%00010000
	STA $420C

	RTS

.disjoinOffsets
db $E0, $00, $F0, $20, $00, $E0, $10, $00, $20

.horizontalShiftUpdate
	LDX #$04
	LDY #$0C

-	LDA !individualoffsets+5,x
	BMI +

	LDA !individualoffsets,x
	CMP #$20
	BMI ++
	SEC
	ROR !individualoffsets+5,x

++	INC
	BRA ++

+	LDA !individualoffsets,x
	CMP #$E2
	BPL +
	CLC
	ROR !individualoffsets+5,x

+	DEC
++	STA !individualoffsets,x
	STA !HDMA+1,y
	
	DEY #3
	DEX
	BPL -

	RTS

.mixedInit
	JSR .columnsDisjoinInit

.horizontalShiftInit
!channel = $40
	LDA #$0D
	STA $4301|!channel

	LDX #$0F
	LDA #$10
-	STA !HDMA,x
	STZ !HDMA+2,x
	DEX #3
	BPL -

	LDA !BG1xpos
	STA !HDMA+16
	STZ !HDMA+17
	STZ !HDMA+18
	LDA #$38
	STA !HDMA

	LDX #$04
	LDY #$0C

-	JSR GetRand

	LSR #2
	ROR !individualoffsets+5,x

;	STA $00
;	XBA
;	AND #$1F
;	SEC
;	ADC $00

	AND #$3F
	SEC
	SBC #$20

	STA !individualoffsets,x
	STA !HDMA+1,y

	DEY #3
	DEX
	BPL -

	LDA #%00010000
	STA $420C

	RTS

.verticalShiftUpdate
	LDA #$2A
	STA $2116
	LDA #$24
	STA $2117

	LDY #$20
	LDX #$04

-	LDA !individualoffsets+5,x
	BMI +

	LDA !individualoffsets,x
	CMP #$1E
	BMI ++
	SEC
	ROR !individualoffsets+5,x

++	INC
	BRA ++

+	LDA !individualoffsets,x
	CMP #$E0
	BPL +
	CLC
	ROR !individualoffsets+5,x

+	DEC
++	STA !individualoffsets,x

	STA $2118
	STY $2119
	STA $2118
	STY $2119

	DEX
	BPL -
	RTS

.verticalShiftInit
	LDA #$2A
	STA $2116
	LDA #$24
	STA $2117

	LDY #$20
	LDX #$04

-	JSR GetRand

	LSR
	ROR !individualoffsets+5,x

	AND #$3F
	SEC
	SBC #$20

	STA !individualoffsets,x

	STA $2118
	STY $2119
	STA $2118
	STY $2119

	DEX
	BPL -
	RTS

.tilemapDrawNMI
	LDA !tilemaptimer
	CMP #$28
	BEQ +++
	CMP #$10
	BNE ++

	LDA !winner
	BNE ++++

	JSR DrawCurrentPlayer

	LDA !roundnumber

	LDY #$38
	CMP #$09
	BCC +

	LDX #$31
	STX $2118
	STY $2119

	SBC #$0A
	CLC
+	ADC #$31
	STA $2118
	STY $2119
	
++	RTS

++++
	REP #$20

	LDA #$E31C
	STA !window1leftpos
	STZ !window2leftpos

	SEP #$20

	LDA #%11000000
	STA $420C

	INC !updatetext
	LDA #$03
	STA !substate

	RTS

	;put tile data on VRAM
+++	REP #$21

	LDA.w #!playfield
	STA $00
	
	LDX #$08
	LDA #$18AB
--	STA $02
	STA $2116

	LDY #$08
-	LDA ($00),y
	STA $2118
	ORA #$4000
	STA $2118

	DEY #2
	BPL -

	LDA $02
	ADC #$0020
	STA $02
	STA $2116

	LDY #$08
-	LDA ($00),y
	ORA #$8000
	STA $2118
	ORA #$4000
	STA $2118

	DEY #2
	BPL -

	LDA $00
	ADC #$000A
	STA $00

	LDA $02
	ADC #$0020

	DEX #2
	BPL --

	;put tiles alongside the buttons
	LDX #!currenttiles
	LDY #$00
	LDA #$0007
	MVN $00, $00

	BIT !randresult
	BPL +
	PEI ($02)
	LDA $04
	STA $02
	PLA
	STA $04

+	BVC +
	PEI ($02)
	LDA $06
	STA $02
	PLA
	STA $06

+	LDX !correcttile
	PEI ($00)
	LDA $00,x
	STA $00
	PLA
	STA $00,x

	LDX #$06
-	LDA .buttonTilePositions,x
	STA $2116
	LDA $00,x
	STA $2118
	ORA #$4000
	STA $2118

	LDA .buttonTilePositions,x
	ORA #$0020
	STA $2116
	LDA $00,x
	ORA #$8000
	STA $2118
	ORA #$4000
	STA $2118

	LDA .buttonTilePositions,x
	ORA #$0010
	STA $2116
	LDA $00,x
	STA $2118
	ORA #$4000
	STA $2118

	LDA .buttonTilePositions,x
	ORA #$0030
	STA $2116
	LDA $00,x
	ORA #$8000
	STA $2118
	ORA #$4000
	STA $2118

	DEX #2
	BPL -

	;clear vertical offsets
	LDA #$2400
	STA $2116

	LDX #$3F
-	STZ $2118
	DEX
	BPL -

	;turn off windows
	STZ !windowmasksettingsBG1BG2

	JSR OAMClear

	SEP #$20

	STZ $420C	;end HDMA

	LDA !roundnumber
	ASL
	TAX
	JMP (.behaviourInitPointers,x)

.buttonTilePositions
dw $1B89	;right
dw $1B85	;left
dw $1BC7	;down
dw $1B47	;up

IRQ:
	SEP #$20
	PHA

	LDA #$80
	STA $2100	;force blank

	LDA #$09
	STA $2105	;BG gamemode

	LDA.b #!tilemapstart>>9+8
	STA $2109	;BG3 tilemap adress

	LDA #$4B
	STA $2112	;BG3 y pos
	STZ $2112	;

	LDA #$1F
	STA $210E	;BG1 y pos
	STZ $210E	;

	STZ $2123	;window mask settings

	LDA !brightness
	STA $2100	;force blank

	LDA $4211

	PLA
	RTI
